//
//  ColorDescriptor.hpp
//  tilemaker
//
//  Created by Attila Zsaki on 2015-10-28.
//  Copyright © 2015 Attila Zsaki. All rights reserved.
//

#ifndef ColorDescriptor_hpp
#define ColorDescriptor_hpp

#include <stdio.h>
#include <string>

#include "ColorRGBA.hpp"
#include "UtilityFunctions.hpp"

using namespace std;

class ColorDescriptor
{
public:
    ColorDescriptor();
    ~ColorDescriptor();
    
    ColorRGBA GetColor(double x, double y, double* noiseValue);
    
    
private:

    double Lerp(double a, double b, double x);
    ColorRGBA ColorLerp(ColorRGBA a, ColorRGBA b, double x);
    
    
public:
    
    ColorRGBA color;
    ColorRGBA colorLowSide;
    ColorRGBA colorHighSide;
    
    string colorType; // solid, variable
    string colorNoiseType; // random, noiseFunctionName(perlin,cosineModulated,marble,wood),
    double noiseXMin;
    double noiseYMin;
    double noiseXMax;
    double noiseYMax;
    
    int octaves;
    double persistence;
    
    // cosine modulated function
    double parameterA;
    
};

inline double ColorDescriptor::Lerp(double a, double b, double x)
{
    return (a+x*(b-a));
}

#endif /* ColorDescriptor_hpp */
