//
//  main.cpp
//  tilemaker
//
//  Created by Attila Zsaki on 2015-10-26.
//  Copyright © 2015 Attila Zsaki. All rights reserved.
//

#include <iostream>
#include <fstream>
#include <sstream>
//#include <string>
//#include <iomanip>
//#include <vector>
//#include <list>
#include <float.h>


#include "RectangularTileMaker.hpp"
#include "ColorRGBA.hpp"

void ReadParameters(const char* fileName, RectangularTileMaker* tileMaker);

using namespace std;

class BadConversion:public std::runtime_error
{
public:
    BadConversion(const std::string& s)
    : std::runtime_error(s) { }
};


int main(int argc, const char * argv[]) {
    
    
    if (argc==2) {
        
        RectangularTileMaker tilemaker=RectangularTileMaker();
        
        const char* fileName=argv[1];
        
        ReadParameters(fileName,&tilemaker);
        
        tilemaker.GenerateTexture();
    }
    
    
    
    RectangularTileMaker tilemaker=RectangularTileMaker();
 
/*
    // input defintion
    tilemaker.SetTiledAreaWidth(10.0);
    tilemaker.SetTiledAreaLength(10.0);
    
    tilemaker.SetTileWidth(2.0);
    tilemaker.SetTileLength(0.4);
    
    tilemaker.SetGroutWidth(0.02);
    
    tilemaker.SetTileXOffset(0.5+0.02*0.5); // half a tile + half a grout
    
    tilemaker.GetTileColorDescriptorGlobal()->colorType="variable";
    tilemaker.GetTileColorDescriptorGlobal()->colorNoiseType="perlin";
    tilemaker.GetTileColorDescriptorGlobal()->color=ColorRGBA(1.0,1.0,1.0,1.0);
    tilemaker.GetTileColorDescriptorGlobal()->colorLowSide=ColorRGBA(1.0,1.0,239.0/255.0,1.0);
    tilemaker.GetTileColorDescriptorGlobal()->colorHighSide=ColorRGBA(1.0,248.0/255.0,227.0/255.0,1.0);
    tilemaker.GetTileColorDescriptorGlobal()->noiseXMin=0.0;
    tilemaker.GetTileColorDescriptorGlobal()->noiseYMin=0.0;
    tilemaker.GetTileColorDescriptorGlobal()->noiseXMax=10.0;
    tilemaker.GetTileColorDescriptorGlobal()->noiseYMax=10.0;
    
    tilemaker.GetTileColorDescriptorLocal()->colorType="variable";
    //tilemaker.GetTileColorDescriptorLocal()->colorType="solid";
    tilemaker.GetTileColorDescriptorLocal()->colorNoiseType="wood";
    tilemaker.GetTileColorDescriptorLocal()->color=ColorRGBA(86.0/256.0,47.0/256.0,14.0/256.00,1.0);
    //tilemaker.GetTileColorDescriptorLocal()->colorLowSide=ColorRGBA(1.0,1.0,239.0/255.0,1.0);
    //tilemaker.GetTileColorDescriptorLocal()->colorHighSide=ColorRGBA(1.0,248.0/255.0,227.0/255.0,1.0);
    tilemaker.GetTileColorDescriptorLocal()->colorLowSide=ColorRGBA(71.0/256.0,35.0/256.0,5.0/256.0,1.0);
    tilemaker.GetTileColorDescriptorLocal()->colorHighSide=ColorRGBA(168.0/256.0,102.0/256.0,46.0/256/0,1.0);
    tilemaker.GetTileColorDescriptorLocal()->noiseXMin=0.0;
    tilemaker.GetTileColorDescriptorLocal()->noiseYMin=0.0;
    tilemaker.GetTileColorDescriptorLocal()->noiseXMax=10.0;
    tilemaker.GetTileColorDescriptorLocal()->noiseYMax=50.0;
    tilemaker.GetTileColorDescriptorLocal()->octaves=2;
    tilemaker.GetTileColorDescriptorLocal()->persistence=0.25;
    tilemaker.GetTileColorDescriptorLocal()->parameterA=20.0;
    
    tilemaker.GetTileBumpNoiseAlternate()->colorType="variable";
    tilemaker.GetTileBumpNoiseAlternate()->colorNoiseType="perlin";
    tilemaker.GetTileBumpNoiseAlternate()->color=ColorRGBA(1.0,1.0,1.0,1.0);
    tilemaker.GetTileBumpNoiseAlternate()->colorLowSide=ColorRGBA(1.0,1.0,1.0,1.0);
    tilemaker.GetTileBumpNoiseAlternate()->colorHighSide=ColorRGBA(1.0,1.0,1.0,1.0);
    tilemaker.GetTileBumpNoiseAlternate()->noiseXMin=0.0;
    tilemaker.GetTileBumpNoiseAlternate()->noiseYMin=0.0;
    tilemaker.GetTileBumpNoiseAlternate()->noiseXMax=2.0;
    tilemaker.GetTileBumpNoiseAlternate()->noiseYMax=2.0;
    tilemaker.GetTileBumpNoiseAlternate()->octaves=2;
    tilemaker.GetTileBumpNoiseAlternate()->persistence=0.25;
    
    tilemaker.GetTileDiscolorationMap()->colorType="variable";
    tilemaker.GetTileDiscolorationMap()->colorNoiseType="perlin";
    tilemaker.GetTileDiscolorationMap()->color=ColorRGBA(1.0,1.0,1.0,1.0);
    tilemaker.GetTileDiscolorationMap()->colorLowSide=ColorRGBA(1.0,1.0,1.0,1.0);
    tilemaker.GetTileDiscolorationMap()->colorHighSide=ColorRGBA(1.0,1.0,1.0,1.0);
    tilemaker.GetTileDiscolorationMap()->noiseXMin=1.0;
    tilemaker.GetTileDiscolorationMap()->noiseYMin=1.0;
    tilemaker.GetTileDiscolorationMap()->noiseXMax=1.5;
    tilemaker.GetTileDiscolorationMap()->noiseYMax=1.5;
    tilemaker.GetTileDiscolorationMap()->octaves=16;
    tilemaker.GetTileDiscolorationMap()->persistence=1.0;
    
    tilemaker.DiscolorationMapTheresholdLower(0.5);
    tilemaker.DiscolorationMapTheresholdUpper(1.0);
    tilemaker.DiscolorationMapTheresholdPercentReduction(20.0);
    tilemaker.GenerateTileDiscolorationMap(true);
    
    
    tilemaker.GetGroutColorDescriptor()->colorType="variable";
    tilemaker.GetGroutColorDescriptor()->colorNoiseType="random";
    tilemaker.GetGroutColorDescriptor()->color=ColorRGBA(0.5,0.5,0.5,1.0);
    tilemaker.GetGroutColorDescriptor()->colorLowSide=ColorRGBA(0.4,0.4,0.4,1.0);
    tilemaker.GetGroutColorDescriptor()->colorHighSide=ColorRGBA(0.6,0.6,0.6,1.0);
    
    tilemaker.SetTextureWidth(2048);
    tilemaker.SetTextureHeight(2048);
    
    tilemaker.SetRandomTileOrientation(false);
    tilemaker.SetRandomTileNoiseStartPoint(true);
    
    tilemaker.UseTileXOffset();
    
    tilemaker.SetGenerateBumpMap(true);
    tilemaker.SetTileBumpNoiseAlternate(true);
    
    tilemaker.BlurFinalImage(false);
    
    tilemaker.GenerateTexture("/Users/attilazsaki/Desktop/testfile.tif");
*/
    
    /*
    
    int iSizeI=10;
    int iSizeJ=10;

    Image tileImage(Geometry(iSizeI,iSizeJ),Color(MaxRGB,MaxRGB,MaxRGB,0));
    
    
    unsigned int rows=tileImage.rows();
    unsigned int columns=tileImage.columns();
    
    
    cout << "rows: " << rows << endl;
    cout << "columns: " << columns << endl;
    
    cout << "MaxRGB: " << MaxRGB << endl;
    

    
    PerlinNoise noise=PerlinNoise();
    
    double rangeXMin=1.11;
    double rangeXMax=4.10;
    double rangeYMin=1.11;
    double rangeYMax=4.10;
    
    int iOctaves=8;
    double dPersistence=0.1;
    
    double delX=(rangeXMax-rangeXMin)/columns;
    double delY=(rangeYMax-rangeYMin)/rows;
    
    int currentColumn=0;
    int currentRow=0;
    
    double minValue=DBL_MAX;
    double maxValue=-DBL_MAX;
    
    
    
    for (double i=rangeXMin;i<rangeXMax;i+=delX) {
        for (double j=rangeYMin;j<rangeYMax;j+=delY) {
    
            //double noiseValue=noise.Perlin(i,j,0.0);
            double noiseValue=noise.OctavePerlin(i,j,0.0,iOctaves,dPersistence);
            
            noiseValue=noise.OctavePerlin(i,j,0.0,iOctaves,dPersistence);
            
            //noiseValue=(sin(2.0*(i+sin(noiseValue)*6.0))+1.0)*0.5;
            
            if (noiseValue<minValue) {
                minValue=noiseValue;
            }
            if (noiseValue>maxValue) {
                maxValue=noiseValue;
            }
            
            
            //
            //if (noiseValue>0.8) {
            //    noiseValue=1.0;
            //}
            //else {
            //    noiseValue=0.0;
            //}
            //
            
            
            int currentColor=noiseValue*MaxRGB;
            
            tileImage.pixelColor(currentColumn,currentRow,Color(currentColor,currentColor,currentColor,0));
            
            ++currentColumn;
        }
        currentColumn=0;
        ++currentRow;
    }
    
    cout << "noise maxValue: " << maxValue << endl;
    cout << "noise minValue: " << minValue << endl;
    
    tileImage.write("/Users/attilazsaki/Desktop/testfile.tif");
*/
    
    return (0);
}

double ConvertToDouble(const std::string& s)
{
    std::istringstream sstream(s);
    double x;
    if (!(sstream >> x))
        throw BadConversion("convertToDouble(\"" + s + "\")");
    return x;
}

int ConvertToInteger(const std::string& s)
{
    std::istringstream sstream(s);
    int x;
    if (!(sstream >> x))
        throw BadConversion("convertToInteger(\"" + s + "\")");
    return x;
}

long ConvertToLong(const std::string& s)
{
    std::istringstream sstream(s);
    long x;
    if (!(sstream >> x))
        throw BadConversion("convertToLong(\"" + s + "\")");
    return x;
}

vector<string> ParseLine(const string& s)
{
    vector<string> result;
    string oneItem;
    stringstream sstream(s);
    
    while (sstream >> oneItem) {
        result.push_back(oneItem);
    }
    
    return (result);
}

bool IsNotAllSpace(const string& s)
{
    const char* p=s.c_str();
    
    while (*p==' ') {
        ++p;
    }
    
    return (*p!=0);
}

void ReadParameters(const char* fileName, RectangularTileMaker* tileMaker)
{
    

    string oneInputLine;
    ifstream inputFile;
    
    inputFile.open(fileName);
    
    if (inputFile.is_open()) {
        while (!inputFile.eof() ) {
            getline (inputFile,oneInputLine);
            
            if (IsNotAllSpace(oneInputLine)) {
                
                vector<string> result=ParseLine(oneInputLine);
                
                if (!result[0].compare("outputFileName")) {
                    tileMaker->SetOutputFileName(result[1]);
                }
                if (!result[0].compare("textureWidth")) {
                    tileMaker->SetTextureWidth(ConvertToInteger(result[1]));
                }
                if (!result[0].compare("textureHeight")) {
                    tileMaker->SetTextureHeight(ConvertToInteger(result[1]));
                }
                if (!result[0].compare("tiledAreaWidth")) {
                    tileMaker->SetTiledAreaWidth(ConvertToDouble(result[1]));
                }
                if (!result[0].compare("tiledAreaLength")) {
                    tileMaker->SetTiledAreaLength(ConvertToDouble(result[1]));
                }
                if (!result[0].compare("tileWidth")) {
                    tileMaker->SetTileWidth(ConvertToDouble(result[1]));
                }
                if (!result[0].compare("tileLength")) {
                    tileMaker->SetTileLength(ConvertToDouble(result[1]));
                }
                if (!result[0].compare("groutWidth")) {
                    tileMaker->SetGroutWidth(ConvertToDouble(result[1]));
                }
                if (!result[0].compare("tileXOffset")) {
                    tileMaker->SetTileXOffset(ConvertToDouble(result[1]));
                }
                if (!result[0].compare("randomTileOrientation")) {
                    if (!result[1].compare("true")) {
                        tileMaker->SetRandomTileOrientation(true);
                    }
                    else {
                        tileMaker->SetRandomTileOrientation(false);
                    }
                }
                if (!result[0].compare("randomTileNoiseStartPoint")) {
                    if (!result[1].compare("true")) {
                        tileMaker->SetRandomTileNoiseStartPoint(true);
                    }
                    else {
                        tileMaker->SetRandomTileNoiseStartPoint(false);
                    }
                }
                if (!result[0].compare("useTileXOffset")) {
                    tileMaker->UseTileXOffset();
                }
                if (!result[0].compare("generateBumpMap")) {
                    if (!result[1].compare("true")) {
                        tileMaker->SetGenerateBumpMap(true);
                    }
                    else {
                        tileMaker->SetGenerateBumpMap(false);
                    }
                }
                if (!result[0].compare("tileBumpNoiseAlternate")) {
                    if (!result[1].compare("true")) {
                        tileMaker->SetTileBumpNoiseAlternate(true);
                    }
                    else {
                        tileMaker->SetTileBumpNoiseAlternate(false);
                    }
                }
                if (!result[0].compare("blurFinalImage")) {
                    if (!result[1].compare("true")) {
                        tileMaker->BlurFinalImage(true);
                    }
                    else {
                        tileMaker->BlurFinalImage(false);
                    }
                }
                
                // tile color global
                if (!result[0].compare("tileColorGlobalColorType")) {
                    tileMaker->GetTileColorDescriptorGlobal()->colorType=result[1];
                }
                if (!result[0].compare("tileColorGlobalColorNoiseType")) {
                    tileMaker->GetTileColorDescriptorGlobal()->colorNoiseType=result[1];
                }
                if (!result[0].compare("tileColorGlobalColor")) {
                    tileMaker->GetTileColorDescriptorGlobal()->color.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileColorDescriptorGlobal()->color.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileColorDescriptorGlobal()->color.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileColorDescriptorGlobal()->color.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileColorGlobalColorLowSide")) {
                    tileMaker->GetTileColorDescriptorGlobal()->colorLowSide.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileColorDescriptorGlobal()->colorLowSide.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileColorDescriptorGlobal()->colorLowSide.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileColorDescriptorGlobal()->colorLowSide.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileColorGlobalColorHighSide")) {
                    tileMaker->GetTileColorDescriptorGlobal()->colorHighSide.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileColorDescriptorGlobal()->colorHighSide.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileColorDescriptorGlobal()->colorHighSide.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileColorDescriptorGlobal()->colorHighSide.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileColorGlobalNoiseXMin")) {
                    tileMaker->GetTileColorDescriptorGlobal()->noiseXMin=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileColorGlobalNoiseYMin")) {
                    tileMaker->GetTileColorDescriptorGlobal()->noiseYMin=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileColorGlobalNoiseXMax")) {
                    tileMaker->GetTileColorDescriptorGlobal()->noiseXMax=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileColorGlobalNoiseYMax")) {
                    tileMaker->GetTileColorDescriptorGlobal()->noiseYMax=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileColorGlobalOctaves")) {
                    tileMaker->GetTileColorDescriptorGlobal()->octaves=ConvertToInteger(result[1]);
                }
                if (!result[0].compare("tileColorGlobalPersistence")) {
                    tileMaker->GetTileColorDescriptorGlobal()->persistence=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileColorGlobalParameterA")) {
                    tileMaker->GetTileColorDescriptorGlobal()->parameterA=ConvertToDouble(result[1]);
                }
                
                // tile color local
                if (!result[0].compare("tileColorLocalColorType")) {
                    tileMaker->GetTileColorDescriptorLocal()->colorType=result[1];
                }
                if (!result[0].compare("tileColorLocalColorNoiseType")) {
                    tileMaker->GetTileColorDescriptorLocal()->colorNoiseType=result[1];
                }
                if (!result[0].compare("tileColorLocalColor")) {
                    tileMaker->GetTileColorDescriptorLocal()->color.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileColorDescriptorLocal()->color.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileColorDescriptorLocal()->color.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileColorDescriptorLocal()->color.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileColorLocalColorLowSide")) {
                    tileMaker->GetTileColorDescriptorLocal()->colorLowSide.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileColorDescriptorLocal()->colorLowSide.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileColorDescriptorLocal()->colorLowSide.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileColorDescriptorLocal()->colorLowSide.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileColorLocalColorHighSide")) {
                    tileMaker->GetTileColorDescriptorLocal()->colorHighSide.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileColorDescriptorLocal()->colorHighSide.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileColorDescriptorLocal()->colorHighSide.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileColorDescriptorLocal()->colorHighSide.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileColorLocalNoiseXMin")) {
                    tileMaker->GetTileColorDescriptorLocal()->noiseXMin=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileColorLocalNoiseYMin")) {
                    tileMaker->GetTileColorDescriptorLocal()->noiseYMin=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileColorLocalNoiseXMax")) {
                    tileMaker->GetTileColorDescriptorLocal()->noiseXMax=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileColorLocalNoiseYMax")) {
                    tileMaker->GetTileColorDescriptorLocal()->noiseYMax=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileColorLocalOctaves")) {
                    tileMaker->GetTileColorDescriptorLocal()->octaves=ConvertToInteger(result[1]);
                }
                if (!result[0].compare("tileColorLocalPersistence")) {
                    tileMaker->GetTileColorDescriptorLocal()->persistence=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileColorLocalParameterA")) {
                    tileMaker->GetTileColorDescriptorLocal()->parameterA=ConvertToDouble(result[1]);
                }
                
                // grout color
                if (!result[0].compare("groutColorColorType")) {
                    tileMaker->GetGroutColorDescriptor()->colorType=result[1];
                }
                if (!result[0].compare("groutColorColorNoiseType")) {
                    tileMaker->GetGroutColorDescriptor()->colorNoiseType=result[1];
                }
                if (!result[0].compare("groutColorColor")) {
                    tileMaker->GetGroutColorDescriptor()->color.dR=ConvertToDouble(result[1]);
                    tileMaker->GetGroutColorDescriptor()->color.dG=ConvertToDouble(result[2]);
                    tileMaker->GetGroutColorDescriptor()->color.dB=ConvertToDouble(result[3]);
                    tileMaker->GetGroutColorDescriptor()->color.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("groutColorColorLowSide")) {
                    tileMaker->GetGroutColorDescriptor()->colorLowSide.dR=ConvertToDouble(result[1]);
                    tileMaker->GetGroutColorDescriptor()->colorLowSide.dG=ConvertToDouble(result[2]);
                    tileMaker->GetGroutColorDescriptor()->colorLowSide.dB=ConvertToDouble(result[3]);
                    tileMaker->GetGroutColorDescriptor()->colorLowSide.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("groutColorColorHighSide")) {
                    tileMaker->GetGroutColorDescriptor()->colorHighSide.dR=ConvertToDouble(result[1]);
                    tileMaker->GetGroutColorDescriptor()->colorHighSide.dG=ConvertToDouble(result[2]);
                    tileMaker->GetGroutColorDescriptor()->colorHighSide.dB=ConvertToDouble(result[3]);
                    tileMaker->GetGroutColorDescriptor()->colorHighSide.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("groutColorNoiseXMin")) {
                    tileMaker->GetGroutColorDescriptor()->noiseXMin=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("groutColorNoiseYMin")) {
                    tileMaker->GetGroutColorDescriptor()->noiseYMin=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("groutColorNoiseXMax")) {
                    tileMaker->GetGroutColorDescriptor()->noiseXMax=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("groutColorNoiseYMax")) {
                    tileMaker->GetGroutColorDescriptor()->noiseYMax=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("groutColorOctaves")) {
                    tileMaker->GetGroutColorDescriptor()->octaves=ConvertToInteger(result[1]);
                }
                if (!result[0].compare("groutColorPersistence")) {
                    tileMaker->GetGroutColorDescriptor()->persistence=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("groutColorParameterA")) {
                    tileMaker->GetGroutColorDescriptor()->parameterA=ConvertToDouble(result[1]);
                }
                
                // tile bump noise color
                if (!result[0].compare("tileBumpNoiseAlternateColorType")) {
                    tileMaker->GetTileBumpNoiseAlternate()->colorType=result[1];
                }
                if (!result[0].compare("tileBumpNoiseAlternateColorNoiseType")) {
                    tileMaker->GetTileBumpNoiseAlternate()->colorNoiseType=result[1];
                }
                if (!result[0].compare("tileBumpNoiseAlternateColor")) {
                    tileMaker->GetTileBumpNoiseAlternate()->color.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileBumpNoiseAlternate()->color.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileBumpNoiseAlternate()->color.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileBumpNoiseAlternate()->color.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileBumpNoiseAlternateColorLowSide")) {
                    tileMaker->GetTileBumpNoiseAlternate()->colorLowSide.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileBumpNoiseAlternate()->colorLowSide.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileBumpNoiseAlternate()->colorLowSide.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileBumpNoiseAlternate()->colorLowSide.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileBumpNoiseAlternateColorHighSide")) {
                    tileMaker->GetTileBumpNoiseAlternate()->colorHighSide.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileBumpNoiseAlternate()->colorHighSide.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileBumpNoiseAlternate()->colorHighSide.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileBumpNoiseAlternate()->colorHighSide.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileBumpNoiseAlternateNoiseXMin")) {
                    tileMaker->GetTileBumpNoiseAlternate()->noiseXMin=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileBumpNoiseAlternateNoiseYMin")) {
                    tileMaker->GetTileBumpNoiseAlternate()->noiseYMin=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileBumpNoiseAlternateNoiseXMax")) {
                    tileMaker->GetTileBumpNoiseAlternate()->noiseXMax=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileBumpNoiseAlternateNoiseYMax")) {
                    tileMaker->GetTileBumpNoiseAlternate()->noiseYMax=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileBumpNoiseAlternateOctaves")) {
                    tileMaker->GetTileBumpNoiseAlternate()->octaves=ConvertToInteger(result[1]);
                }
                if (!result[0].compare("tileBumpNoiseAlternatePersistence")) {
                    tileMaker->GetTileBumpNoiseAlternate()->persistence=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileBumpNoiseAlternateParameterA")) {
                    tileMaker->GetTileBumpNoiseAlternate()->parameterA=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileBumpMaxGroutHeight")) {
                    tileMaker->SetMaxGroutBumpHeight(ConvertToDouble(result[1]));
                }
                if (!result[0].compare("tileBumpMaxTileHeight")) {
                    tileMaker->SetMaxTileBumpHeight(ConvertToDouble(result[1]));
                }
                
                // tile discoloration map color
                if (!result[0].compare("tileDiscolorationMapColorType")) {
                    tileMaker->GetTileDiscolorationMap()->colorType=result[1];
                }
                if (!result[0].compare("tileDiscolorationMapColorNoiseType")) {
                    tileMaker->GetTileDiscolorationMap()->colorNoiseType=result[1];
                }
                if (!result[0].compare("tileDiscolorationMapColor")) {
                    tileMaker->GetTileDiscolorationMap()->color.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileDiscolorationMap()->color.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileDiscolorationMap()->color.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileDiscolorationMap()->color.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileDiscolorationMapColorLowSide")) {
                    tileMaker->GetTileDiscolorationMap()->colorLowSide.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileDiscolorationMap()->colorLowSide.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileDiscolorationMap()->colorLowSide.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileDiscolorationMap()->colorLowSide.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileDiscolorationMapColorHighSide")) {
                    tileMaker->GetTileDiscolorationMap()->colorHighSide.dR=ConvertToDouble(result[1]);
                    tileMaker->GetTileDiscolorationMap()->colorHighSide.dG=ConvertToDouble(result[2]);
                    tileMaker->GetTileDiscolorationMap()->colorHighSide.dB=ConvertToDouble(result[3]);
                    tileMaker->GetTileDiscolorationMap()->colorHighSide.dA=ConvertToDouble(result[4]);
                }
                if (!result[0].compare("tileDiscolorationMapNoiseXMin")) {
                    tileMaker->GetTileDiscolorationMap()->noiseXMin=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileDiscolorationMapNoiseYMin")) {
                    tileMaker->GetTileDiscolorationMap()->noiseYMin=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileDiscolorationMapNoiseXMax")) {
                    tileMaker->GetTileDiscolorationMap()->noiseXMax=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileDiscolorationMapNoiseYMax")) {
                    tileMaker->GetTileDiscolorationMap()->noiseYMax=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileDiscolorationMapOctaves")) {
                    tileMaker->GetTileDiscolorationMap()->octaves=ConvertToInteger(result[1]);
                }
                if (!result[0].compare("tileDiscolorationMapPersistence")) {
                    tileMaker->GetTileDiscolorationMap()->persistence=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileDiscolorationMapParameterA")) {
                    tileMaker->GetTileDiscolorationMap()->parameterA=ConvertToDouble(result[1]);
                }
                if (!result[0].compare("tileDiscolorationMapThresholdLower")) {
                    tileMaker->DiscolorationMapTheresholdLower(ConvertToDouble(result[1]));
                }
                if (!result[0].compare("tileDiscolorationMapThresholdUpper")) {
                    tileMaker->DiscolorationMapTheresholdUpper(ConvertToDouble(result[1]));
                }
                if (!result[0].compare("tileDiscolorationMapThresholdPercentReduction")) {
                    tileMaker->DiscolorationMapTheresholdPercentReduction(ConvertToDouble(result[1]));
                }
                if (!result[0].compare("tileDiscolorationMapGenerate")) {
                    if (!result[1].compare("true")) {
                        tileMaker->GenerateTileDiscolorationMap(true);
                    }
                    else {
                        tileMaker->GenerateTileDiscolorationMap(false);
                    }
                }
            }
        }
    }

}
